module UseTask (downloadAll2) where

import Lib (fetcher)
import Task

downloadAll2 :: IO Bool
downloadAll2 = do
  downloadTask <- newTask 5
  addTask downloadTask $ fetcher "url0"
  let urlBatch1 = ["url1", "url2", "url3"]
  addTasks downloadTask $ map fetcher urlBatch1
  let urlBatch2 = ["url4", "url5", "url6", "url7", "url8"]
  addTasks downloadTask $ map fetcher urlBatch2

  results1 <- getTaskResults downloadTask

  let urlBatch3 = ["url9", "url10", "url11", "url12", "url13", "url14"]
  addTasks downloadTask $ map fetcher urlBatch3

  results2 <- getTaskResults downloadTask

  let results = results1 <> results2
      totalCount = length results
      failedCount = length (filter (not . id) results)
  putStrLn $ show totalCount <> " task ran"
  putStrLn $ show failedCount <> " failed"
  return $ and results
